Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.compress.archivers.tar
Class TarArchiveEntry

    java.lang.Object
      org.apache.commons.compress.archivers.tar.TarArchiveEntry

All Implemented Interfaces:
  ArchiveEntry, TarConstants

    public class TarArchiveEntry

extends Object
implements TarConstants, ArchiveEntry

This class represents an entry in a Tar archive. It consists of the entry's header, as well as the entry's File. Entries can be instantiated in one of three ways, depending on how they are to be used.

TarEntries that are created from the header bytes read from an archive are instantiated with the TarEntry( byte[] ) constructor. These entries will be used when extracting from or listing the contents of an archive. These entries have their header filled in using the header bytes. They also set the File to null, since they reference an archive entry not a file.

TarEntries that are created from Files that are to be written into an archive are instantiated with the TarEntry( File ) constructor. These entries have their header filled in using the File's information. They also keep a reference to the File for convenience when writing entries.

Finally, TarEntries can be constructed from nothing but a name. This allows the programmer to construct the entry by hand, for instance when only an InputStream is available for writing to the archive, and the header information is constructed from other information. In this case the header fields are set to defaults and the File is set to null.

The C structure for a Tar Entry's header is:

     struct header {
     char name[100];     // TarConstants.NAMELEN    - offset   0
     char mode[8];       // TarConstants.MODELEN    - offset 100
     char uid[8];        // TarConstants.UIDLEN     - offset 108
     char gid[8];        // TarConstants.GIDLEN     - offset 116
     char size[12];      // TarConstants.SIZELEN    - offset 124
     char mtime[12];     // TarConstants.MODTIMELEN - offset 136
     char chksum[8];     // TarConstants.CHKSUMLEN  - offset 148
     char linkflag[1];   //                         - offset 156
     char linkname[100]; // TarConstants.NAMELEN    - offset 157
     The following fields are only present in new-style POSIX tar archives:
     char magic[6];      // TarConstants.MAGICLEN   - offset 257
     char version[2];    // TarConstants.VERSIONLEN - offset 263
     char uname[32];     // TarConstants.UNAMELEN   - offset 265
     char gname[32];     // TarConstants.GNAMELEN   - offset 297
     char devmajor[8];   // TarConstants.DEVLEN     - offset 329
     char devminor[8];   // TarConstants.DEVLEN     - offset 337
     char prefix[155];   // TarConstants.PREFIXLEN  - offset 345
     // Used if "name" field is not long enough to hold the path
     char pad[12];       // NULs                    - offset 500
     } header;
     All unused bytes are set to null.
     New-style GNU tar files are slightly different from the above.

The C structure for a old GNU Tar Entry's header is:

     struct oldgnu_header {
     char unused_pad1[345]; // TarConstants.PAD1LEN_GNU       - offset 0
     char atime[12];        // TarConstants.ATIMELEN_GNU      - offset 345
     char ctime[12];        // TarConstants.CTIMELEN_GNU      - offset 357
     char offset[12];       // TarConstants.OFFSETLEN_GNU     - offset 369
     char longnames[4];     // TarConstants.LONGNAMESLEN_GNU  - offset 381
     char unused_pad2;      // TarConstants.PAD2LEN_GNU       - offset 385
     struct sparse sp[4];   // TarConstants.SPARSELEN_GNU     - offset 386
     char isextended;       // TarConstants.ISEXTENDEDLEN_GNU - offset 482
     char realsize[12];     // TarConstants.REALSIZELEN_GNU   - offset 483
     char unused_pad[17];   // TarConstants.PAD3LEN_GNU       - offset 495
     };

Whereas, "struct sparse" is:

     struct sparse {
     char offset[12];   // offset 0
     char numbytes[12]; // offset 12
     };

This class is not thread-safe

Field Summary
`static int` | `DEFAULT_DIR_MODE` Default permissions bits for directories
`static int` | `DEFAULT_FILE_MODE` Default permissions bits for files
`static int` | `MAX_NAMELEN` Maximum length of a user's name in the tar file
`static int` | `MILLIS_PER_SECOND` Convert millis to seconds

Fields inherited from interface org.apache.commons.compress.archivers.tar.TarConstants
`ATIMELEN_GNU, CHKSUMLEN, CTIMELEN_GNU, DEVLEN, FORMAT_OLDGNU, FORMAT_POSIX, GIDLEN, GNAMELEN, GNU_LONGLINK, ISEXTENDEDLEN_GNU, ISEXTENDEDLEN_GNU_SPARSE, LF_BLK, LF_CHR, LF_CONTIG, LF_DIR, LF_FIFO, LF_GNUTYPE_LONGNAME, LF_GNUTYPE_SPARSE, LF_LINK, LF_NORMAL, LF_OLDNORM, LF_PAX_EXTENDED_HEADER_LC, LF_PAX_EXTENDED_HEADER_UC, LF_PAX_GLOBAL_EXTENDED_HEADER, LF_SYMLINK, LONGNAMESLEN_GNU, MAGIC_ANT, MAGIC_GNU, MAGIC_OFFSET, MAGIC_POSIX, MAGICLEN, MAXSIZE, MODELEN, MODTIMELEN, NAMELEN, OFFSETLEN_GNU, PAD2LEN_GNU, PREFIXLEN, REALSIZELEN_GNU, SIZELEN, SPARSELEN_GNU, SPARSELEN_GNU_SPARSE, UIDLEN, UNAMELEN, VERSION_ANT, VERSION_GNU_SPACE, VERSION_GNU_ZERO, VERSION_OFFSET, VERSION_POSIX, VERSIONLEN`

Fields inherited from interface org.apache.commons.compress.archivers.ArchiveEntry
`SIZE_UNKNOWN`

Constructor Summary
`TarArchiveEntry(byte[] headerBuf)` Construct an entry from an archive's header bytes.
`TarArchiveEntry(File file)` Construct an entry for a file.
`TarArchiveEntry(File file, String fileName)` Construct an entry for a file.
`TarArchiveEntry(String name)` Construct an entry with only a name.
`TarArchiveEntry(String name, boolean preserveLeadingSlashes)` Construct an entry with only a name.
`TarArchiveEntry(String name, byte linkFlag)` Construct an entry with a name and a link flag.

Method Summary
`boolean` | `equals(Object it)` Determine if the two entries are equal.
`boolean` | `equals(TarArchiveEntry it)` Determine if the two entries are equal.
`TarArchiveEntry[]` | `getDirectoryEntries()` If this entry represents a file, and the file is a directory, return an array of TarEntries for this entry's children.
`File` | `getFile()` Get this entry's file.
`int` | `getGroupId()` Get this entry's group id.
`String` | `getGroupName()` Get this entry's group name.
`Date` | `getLastModifiedDate()` The last modified date of the entry.
`String` | `getLinkName()` Get this entry's link name.
`int` | `getMode()` Get this entry's mode.
`Date` | `getModTime()` Set this entry's modification time.
`String` | `getName()` Get this entry's name.
`long` | `getRealSize()` Get this entry's real file size in case of a sparse file.
`long` | `getSize()` Get this entry's file size.
`int` | `getUserId()` Get this entry's user id.
`String` | `getUserName()` Get this entry's user name.
`int` | `hashCode()` Hashcodes are based on entry names.
`boolean` | `isBlockDevice()` Check if this is a block device entry.
`boolean` | `isCharacterDevice()` Check if this is a character device entry.
`boolean` | `isDescendent(TarArchiveEntry desc)` Determine if the given entry is a descendant of this entry.
`boolean` | `isDirectory()` Return whether or not this entry represents a directory.
`boolean` | `isExtended()` Indicates in case of a sparse file if an extension sparse header follows.
`boolean` | `isFIFO()` Check if this is a FIFO (pipe) entry.
`boolean` | `isFile()` Check if this is a "normal file"
`boolean` | `isGlobalPaxHeader()` Check if this is a Pax header.
`boolean` | `isGNULongNameEntry()` Indicate if this entry is a GNU long name block
`boolean` | `isGNUSparse()` Indicate if this entry is a GNU sparse block
`boolean` | `isLink()` Check if this is a link entry.
`boolean` | `isPaxHeader()` Check if this is a Pax header.
`boolean` | `isSymbolicLink()` Check if this is a symbolic link entry.
`void` | `parseTarHeader(byte[] header)` Parse an entry's header information from a header buffer.
`void` | `setGroupId(int groupId)` Set this entry's group id.
`void` | `setGroupName(String groupName)` Set this entry's group name.
`void` | `setIds(int userId, int groupId)` Convenience method to set this entry's group and user ids.
`void` | `setLinkName(String link)` Set this entry's link name.
`void` | `setMode(int mode)` Set the mode for this entry
`void` | `setModTime(Date time)` Set this entry's modification time.
`void` | `setModTime(long time)` Set this entry's modification time.
`void` | `setName(String name)` Set this entry's name.
`void` | `setNames(String userName, String groupName)` Convenience method to set this entry's group and user names.
`void` | `setSize(long size)` Set this entry's file size.
`void` | `setUserId(int userId)` Set this entry's user id.
`void` | `setUserName(String userName)` Set this entry's user name.
`void` | `writeEntryHeader(byte[] outbuf)` Write an entry's header information to a header buffer.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### MAX_NAMELEN

    public static final int MAX_NAMELEN

  Maximum length of a user's name in the tar file

  See Also:
    Constant Field Values

### DEFAULT_DIR_MODE

    public static final int DEFAULT_DIR_MODE

  Default permissions bits for directories

  See Also:
    Constant Field Values

### DEFAULT_FILE_MODE

    public static final int DEFAULT_FILE_MODE

  Default permissions bits for files

  See Also:
    Constant Field Values

### MILLIS_PER_SECOND

    public static final int MILLIS_PER_SECOND

  Convert millis to seconds

  See Also:
    Constant Field Values

Constructor Detail

### TarArchiveEntry

    public TarArchiveEntry(String name)

  Construct an entry with only a name. This allows the programmer to construct the entry's header "by hand". File is set to null.

  Parameters:
    `name` - the entry name

### TarArchiveEntry

    public TarArchiveEntry(String name,
                           boolean preserveLeadingSlashes)

  Construct an entry with only a name. This allows the programmer to construct the entry's header "by hand". File is set to null.

  Parameters:
    `name` - the entry name
    `preserveLeadingSlashes` - whether to allow leading slashes in the name.
  Since:
    Apache Commons Compress 1.1

### TarArchiveEntry

    public TarArchiveEntry(String name,
                           byte linkFlag)

  Construct an entry with a name and a link flag.

  Parameters:
    `name` - the entry name
    `linkFlag` - the entry link flag.

### TarArchiveEntry

    public TarArchiveEntry(File file)

  Construct an entry for a file. File is set to file, and the header is constructed from information from the file. The name is set from the normalized file path.

  Parameters:
    `file` - The file that the entry represents.

### TarArchiveEntry

    public TarArchiveEntry(File file,
                           String fileName)

  Construct an entry for a file. File is set to file, and the header is constructed from information from the file.

  Parameters:
    `file` - The file that the entry represents.
    `fileName` - the name to be used for the entry.

### TarArchiveEntry

    public TarArchiveEntry(byte[] headerBuf)

  Construct an entry from an archive's header bytes. File is set to null.

  Parameters:
    `headerBuf` - The header bytes from a tar archive entry.

Method Detail

### equals

    public boolean equals(TarArchiveEntry it)

  Determine if the two entries are equal. Equality is determined by the header names being equal.

  Parameters:
    `it` - Entry to be checked for equality.
  Returns:
    True if the entries are equal.

### equals

    public boolean equals(Object it)

  Determine if the two entries are equal. Equality is determined by the header names being equal.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `it` - Entry to be checked for equality.
  Returns:
    True if the entries are equal.

### hashCode

    public int hashCode()

  Hashcodes are based on entry names.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    the entry hashcode

### isDescendent

    public boolean isDescendent(TarArchiveEntry desc)

  Determine if the given entry is a descendant of this entry. Descendancy is determined by the name of the descendant starting with this entry's name.

  Parameters:
    `desc` - Entry to be checked as a descendent of this.
  Returns:
    True if entry is a descendant of this.

### getName

    public String getName()

  Get this entry's name.

  Specified by:
    `getName` in interface `ArchiveEntry`
  Returns:
    This entry's name.

### setName

    public void setName(String name)

  Set this entry's name.

  Parameters:
    `name` - This entry's new name.

### setMode

    public void setMode(int mode)

  Set the mode for this entry

  Parameters:
    `mode` - the mode for this entry

### getLinkName

    public String getLinkName()

  Get this entry's link name.

  Returns:
    This entry's link name.

### setLinkName

    public void setLinkName(String link)

  Set this entry's link name.

  Parameters:
    `link` - the link name to use.
  Since:
    Apache Commons Compress 1.1

### getUserId

    public int getUserId()

  Get this entry's user id.

  Returns:
    This entry's user id.

### setUserId

    public void setUserId(int userId)

  Set this entry's user id.

  Parameters:
    `userId` - This entry's new user id.

### getGroupId

    public int getGroupId()

  Get this entry's group id.

  Returns:
    This entry's group id.

### setGroupId

    public void setGroupId(int groupId)

  Set this entry's group id.

  Parameters:
    `groupId` - This entry's new group id.

### getUserName

    public String getUserName()

  Get this entry's user name.

  Returns:
    This entry's user name.

### setUserName

    public void setUserName(String userName)

  Set this entry's user name.

  Parameters:
    `userName` - This entry's new user name.

### getGroupName

    public String getGroupName()

  Get this entry's group name.

  Returns:
    This entry's group name.

### setGroupName

    public void setGroupName(String groupName)

  Set this entry's group name.

  Parameters:
    `groupName` - This entry's new group name.

### setIds

    public void setIds(int userId,
                       int groupId)

  Convenience method to set this entry's group and user ids.

  Parameters:
    `userId` - This entry's new user id.
    `groupId` - This entry's new group id.

### setNames

    public void setNames(String userName,
                         String groupName)

  Convenience method to set this entry's group and user names.

  Parameters:
    `userName` - This entry's new user name.
    `groupName` - This entry's new group name.

### setModTime

    public void setModTime(long time)

  Set this entry's modification time. The parameter passed to this method is in "Java time".

  Parameters:
    `time` - This entry's new modification time.

### setModTime

    public void setModTime(Date time)

  Set this entry's modification time.

  Parameters:
    `time` - This entry's new modification time.

### getModTime

    public Date getModTime()

  Set this entry's modification time.

  Returns:
    time This entry's new modification time.

### getLastModifiedDate

    public Date getLastModifiedDate()

  The last modified date of the entry.

  Specified by:
    `getLastModifiedDate` in interface `ArchiveEntry`

### getFile

    public File getFile()

  Get this entry's file.

  Returns:
    This entry's file.

### getMode

    public int getMode()

  Get this entry's mode.

  Returns:
    This entry's mode.

### getSize

    public long getSize()

  Get this entry's file size.

  Specified by:
    `getSize` in interface `ArchiveEntry`
  Returns:
    This entry's file size.

### setSize

    public void setSize(long size)

  Set this entry's file size.

  Parameters:
    `size` - This entry's new file size.
  Throws:
    `IllegalArgumentException` - if the size is < 0 or > `TarConstants.MAXSIZE` (077777777777L).

### isExtended

    public boolean isExtended()

  Indicates in case of a sparse file if an extension sparse header follows.

  Returns:
    true if an extension sparse header follows.

### getRealSize

    public long getRealSize()

  Get this entry's real file size in case of a sparse file.

  Returns:
    This entry's real file size.

### isGNUSparse

    public boolean isGNUSparse()

  Indicate if this entry is a GNU sparse block

  Returns:
    true if this is a sparse extension provided by GNU tar

### isGNULongNameEntry

    public boolean isGNULongNameEntry()

  Indicate if this entry is a GNU long name block

  Returns:
    true if this is a long name extension provided by GNU tar

### isPaxHeader

    public boolean isPaxHeader()

  Check if this is a Pax header.

  Returns:
    `true` if this is a Pax header.
  Since:
    Apache Commons Compress 1.1

### isGlobalPaxHeader

    public boolean isGlobalPaxHeader()

  Check if this is a Pax header.

  Returns:
    `true` if this is a Pax header.
  Since:
    Apache Commons Compress 1.1

### isDirectory

    public boolean isDirectory()

  Return whether or not this entry represents a directory.

  Specified by:
    `isDirectory` in interface `ArchiveEntry`
  Returns:
    True if this entry is a directory.

### isFile

    public boolean isFile()

  Check if this is a "normal file"

  Since:
    Apache Commons Compress 1.2

### isSymbolicLink

    public boolean isSymbolicLink()

  Check if this is a symbolic link entry.

  Since:
    Apache Commons Compress 1.2

### isLink

    public boolean isLink()

  Check if this is a link entry.

  Since:
    Apache Commons Compress 1.2

### isCharacterDevice

    public boolean isCharacterDevice()

  Check if this is a character device entry.

  Since:
    Apache Commons Compress 1.2

### isBlockDevice

    public boolean isBlockDevice()

  Check if this is a block device entry.

  Since:
    Apache Commons Compress 1.2

### isFIFO

    public boolean isFIFO()

  Check if this is a FIFO (pipe) entry.

  Since:
    Apache Commons Compress 1.2

### getDirectoryEntries

    public TarArchiveEntry[] getDirectoryEntries()

  If this entry represents a file, and the file is a directory, return an array of TarEntries for this entry's children.

  Returns:
    An array of TarEntry's for this entry's children.

### writeEntryHeader

    public void writeEntryHeader(byte[] outbuf)

  Write an entry's header information to a header buffer.

  Parameters:
    `outbuf` - The tar entry header buffer to fill in.

### parseTarHeader

    public void parseTarHeader(byte[] header)

  Parse an entry's header information from a header buffer.

  Parameters:
    `header` - The tar entry header buffer to get information from.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2011 The Apache Software Foundation. All Rights Reserved.